/*
	exporter.h
*/

#ifndef __EXPORTER_H__
#define __EXPORTER_H__

#include <fstream>
#include "string.h"


class Graph;


class Exporter
{
protected:
	const String &filename;
	std::fstream fs;

	Exporter (const String fname);

public:
	bool failed;

	static Exporter *make (const String format, const String fname);

	virtual void output (const Graph *g) = 0;
	virtual ~Exporter ();
};

class GraphThing_Exporter : public Exporter
{
public:
	GraphThing_Exporter (const String fname) : Exporter (fname) { }
	void output (const Graph *g);
};

class GraphML_Exporter : public Exporter
{
public:
	GraphML_Exporter (const String fname) : Exporter (fname) { }
	void output (const Graph *g);
};

class Graphviz_Exporter : public Exporter
{
public:
	Graphviz_Exporter (const String fname) : Exporter (fname) { }
	void output (const Graph *g);
};

class Maple_Exporter : public Exporter
{
public:
	Maple_Exporter (const String fname) : Exporter (fname) { }
	void output (const Graph *g);
};

#endif	/* __EXPORTER_H__ */
