/*
	main.cc
*/

#include <gtk--/main.h>
#include <iostream>
#include <stdexcept>
#include "config.h"
#include "gui.h"
#include "lang.h"


#ifdef ENABLE_NLS
Translator *translator;
#endif

static GUI *guiP;

int main (int argc, char *argv[])
{
#ifdef ENABLE_NLS
	translator = new Translator (1);	// be noisy
	try {
		translator->init ();
	} catch (std::runtime_error e) {
		std::cerr << "Translation init failed: " << e.what () << "\n";
		return 1;
	}
	translator->guess_language ();

	translator->verify_phrases ();
#endif

	Gtk::Main kit (argc, argv);
	GUI gui;
	guiP = &gui;

	// Check for filenames on command-line
	if (argc > 1)
		gui.load_graph (argv[1]);

	kit.run ();

#ifdef ENABLE_NLS
	delete translator;
#endif

	return 0;
}

void set_progress (double frac)
{
	guiP->set_progress (frac);
}
