/*
	string.h
*/

#ifndef __STRING_H__
#define __STRING_H__

#include <iostream>
#include <string>


class String
{
private:
	class StringRep
	{
	public:
		char *data;
		unsigned int len, size;
		unsigned int ref;

		StringRep ();
		StringRep (unsigned int n);
		StringRep (const char *s);
		StringRep (const std::string &s);
		~StringRep ();
	};

	StringRep *rep;

	void unref ();

public:
	String ();
	String (const char *s);
	String (const std::string &s);
	String (const String &s);
	~String ();

	int length () const;
	String &append (const char *s);
	String &append (const String &s);
	int compare (const char *s) const;
	int compare (const String &s) const;
	const char *c_str () const;
	std::string std_str () const;
	bool empty () const;

	String &operator= (const String &other);
	String &operator= (const char *s);
	bool operator== (const char *s) const;
	bool operator== (const String &s) const;
	bool operator!= (const char *s) const;
	bool operator!= (const String &s) const;
	bool operator< (const String &s) const;
	String &operator+= (const char *s);
	String &operator+= (const String &s);
	char &operator[] (unsigned int i);
	const char &operator[] (unsigned int i) const;

	friend std::ostream &operator<< (std::ostream &o, const String &s);
	friend String operator+ (const String &s1, const String &s2);
};

#endif	/* __STRING_H__ */
