/*
	undo.h
*/

#ifndef __UNDO_H__
#define __UNDO_H__

#include <stack>
#include "string.h"


class Graph;


class UndoStep
{
private:
	Graph *original_graph;
	const String description;

public:
	UndoStep (Graph *graph, const String desc);
	UndoStep (const UndoStep &other);
	~UndoStep ();

	Graph *getGraph () const;
	const String getMessage () const;
};

class UndoStack
{
private:
	std::stack<UndoStep> undos;

public:
	UndoStack ();
	~UndoStack ();

	bool empty () const;
	unsigned int size () const;
	const UndoStep &top () const;

	void push (UndoStep &step);
	UndoStep &pop ();
};

#endif	/* __UNDO_H__ */
